%function instance_generator
clc 
clear all
close all

%Sets
    nShipTypes=6;
    nTime=60;
    nNodes=4;
    nSpeeds=3;
    nProdTypes=3;
    
    %Subsets    

    Arcs = zeros(nNodes,nNodes);
    for i = 1:nNodes
        for j = 1:nNodes
            if i == j
                Arcs(i,j) = 1;
            else
                Arcs(i,j) = floor(rand()/3+0.9);
            end
        end
    end
    
    for i = 1:nNodes
        for j = 1:nNodes
            if Arcs(i,j)==0;
                Arcs(j,i) = 0;
            end
        end
    end
Length = nNodes*nNodes;
    FArcs = zeros(nNodes,nNodes)
    DArcs = zeros(nNodes,nNodes)
    LArcs=zeros(Length,1);
    LFArcs=zeros(Length,1);
    LDArcs=zeros(Length,1);
temp=0;    
    for i = 1:nNodes
        for j = 1:nNodes
            if i == j
                FArcs(i,j) = 0;
                DArcs(i,j) = 0;
            else
                FArcs(i,j) = round(rand()+0.15)*Arcs(i,j);
                DArcs(i,j) = round(rand()+0.2)*Arcs(i,j);
            end
            temp=temp+1;
            LArcs(temp,1)=Arcs(i,j);
            LFArcs(temp,1)=FArcs(i,j);
            LDArcs(temp,1)=DArcs(i,j);
        end
    end
   
  [ Node_st ] = VesselNode();  

%Parameters

%Given Capacity
    Capacity 	=[	7620 	3600	550
			7934 	3600	1600
 			8014 	3800	2300
			6300	2000	0
 			4474 	4500	2800
 			6004 	7500	4100	] ;
            %HH and NCC valus are based on a hight of 10m...



    TotCap		=[	8000	8500	9000	7000	4500	6000	] ;
            %Estimates for everything exept Mk vessels



    %SailTime
    SailTable = zeros(nNodes,nNodes);
    SailTime = zeros(Length,nSpeeds);
    
    for i = 1:nNodes
        for j = i:nNodes
             number = (rand/1.6+0.3)*15000;
             
            if i == j
                SailTable(i,j) = 1;
            else
                SailTable(i,j) = number;
                SailTable(j,i) = number;
            end
        end
    end

    
    Length2=Length*nShipTypes;
    
    Consumption1=zeros(Length,nSpeeds);
    
        temp = 0;
    for i = 1:nNodes
       for j = 1:nNodes
            temp = temp + 1;
            SailTime(temp,1) = ceil(SailTable(i,j)/(16*24));
            SailTime(temp,2) = ceil(SailTable(i,j)/(18*24));
            SailTime(temp,3) = ceil(SailTable(i,j)/(20*24));
       end
    end


ConsumptionOp=[	42.2	53.3	67.3
                48.2	57.1	67.7
                50.5	57.9	66.3
                36.8	42.5	49.2
                59.0	71.9	86.4
                50.6	60.6	72.6	];
              
ConsumptionPort=[	5	5	5	6.1     8.5     7.5	]';
    
counter=0;  
  for i = 1:Length 
      for j=1:nSpeeds
    
          if i == 1 || i == 6 || i == 11 || i == 16
              Consumption1(i,j)=ConsumptionPort(1);
              Consumption2(i,j)=ConsumptionPort(2);
              Consumption3(i,j)=ConsumptionPort(3);
              Consumption4(i,j)=ConsumptionPort(4);
              Consumption5(i,j)=ConsumptionPort(5);
              Consumption6(i,j)=ConsumptionPort(6);
          else
              Consumption1(i,j) = SailTime(i,j)*ConsumptionOp(1,j);
              Consumption2(i,j) = SailTime(i,j)*ConsumptionOp(2,j);
              Consumption3(i,j) = SailTime(i,j)*ConsumptionOp(3,j);
              Consumption4(i,j) = SailTime(i,j)*ConsumptionOp(4,j);
              Consumption5(i,j) = SailTime(i,j)*ConsumptionOp(5,j);
              Consumption6(i,j) = SailTime(i,j)*ConsumptionOp(6,j);
          end
          
      end
  end
  %Consumption=(Length2,nSpeeds);
  Consumption=[Consumption1;Consumption2;Consumption3;Consumption4;Consumption5;Consumption6];
  %Current cost of HFO= 140 EUR/ton
CostS = zeros(Length,1);
CostS = 71.9*5*ceil(SailTable/(18*24))
CapacityS = [6334 	2100	0];
TotCapS = [6334];
  
      %Frequency
    Fdemand=zeros(Length,1);
    temp=0;  
    for i = 1:nNodes;
        for j = 1:nNodes
            if i==j
            Frequency(i,j)=0;
            else
            Frequency(i,j)=ceil((rand()/14)*nTime)*FArcs(i,j);
            end
        temp = temp + 1;
        Fdemand(temp,1)=Frequency(i,j);    
        end
    end
    
    
    TotProd=zeros(Length,1);
    for i=1:Length
        if LFArcs(i)>=LDArcs(i)
            TotProd(i)=(Fdemand(i)*4200)/nTime+(550*LFArcs(i)-(Fdemand(i)*4200)/nTime)*rand;
        else
            TotProd(i)=round(rand*400)*LDArcs(i);
        end
    end
TotProd
Production = rand(Length,nProdTypes);       % create random matrix of size N x N
sP = sum(Production,2);                      % Sum over each row

for i = 1:Length
 Production(i,:) = (Production(i,:) / sP(i))*TotProd(i);
end

Demand=Production*nTime;

    %Storage capacity
    StorageCap = zeros(Length,1);
    for i = 1:Length
        StorageCap(i)=6000+(16000-6000).*rand;
    end		

    %Size of start storage
    StartStorage = zeros(Length,nProdTypes);
    temp = 0;
    for i = 1:nNodes
        for j = 1:nNodes
            temp = temp + 1;
               if i==j
                   StartStorage(temp,1)=0;
                   StartStorage(temp,2)=0;
                   StartStorage(temp,3)=0;
               else
                    StartStorage(temp,1) = Arcs(i,j)*1500;
                    StartStorage(temp,2) = Arcs(i,j)*1500;
                    StartStorage(temp,3) = Arcs(i,j)*1500;
               end
        end
    end		
    
   
    CharterCost=[23000   23000   23000   28000   28000   33000   ];
    
    

    %Write to file
fid=fopen('DataIG.txt','wt');
			
    fprintf(fid,'!Sets \n');
    fprintf(fid,'nShipTypes :');
        fprintf(fid,'%1.0f \n',nShipTypes);
    fprintf(fid,'nTime :');
        fprintf(fid,'%1.0f\n',nTime);
    fprintf(fid,'nNodes :');
        fprintf(fid,'%1.0f\n',nNodes);
    fprintf(fid,'nSpeeds : ');
        fprintf(fid,'%1.0f\n',nSpeeds);
    fprintf(fid,'nProdTypes :');
        fprintf(fid,'%1.0f \n \n',nProdTypes);

    fprintf(fid,'!Subsets \n');
    fprintf(fid,'Arcs :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f\n',Arcs');
        fprintf(fid,'   ]\n\n');
    fprintf(fid,'Node_st :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f\n',Node_st');
        fprintf(fid,'   ]\n\n');
    
    fprintf(fid,'!Parameters \n');
    fprintf(fid,'SailTime :[\n');
        fprintf(fid,'%14.0f %6.0f %6.0f\n',SailTime');
        fprintf(fid,'                                     ]\n\n');
    fprintf(fid,'Consumption :[\n');
        fprintf(fid,'%14.1f %10.1f %10.1f\n',Consumption');
        fprintf(fid,'                                     ]\n\n');
    fprintf(fid,'Frequency :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f\n',Frequency');
        fprintf(fid,'                                     ]\n\n');
    fprintf(fid,'Demand :[\n');
        fprintf(fid,'%14.0f %6.0f %6.0f\n',Demand');
        fprintf(fid,'                                     ]\n\n');
    fprintf(fid,'Production :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f\n',Production');
        fprintf(fid,'                                     ]\n\n');
    fprintf(fid,'StorageCap :[\n');
        fprintf(fid,'%14.0f\n',StorageCap');
        fprintf(fid,'                                     ]\n\n');       
    fprintf(fid,'StartStorage :[\n');
        fprintf(fid,'%14.0f %6.0f %6.0f\n',StartStorage');
        fprintf(fid,'                                     ]\n\n');
    fprintf(fid,'Capacity :[\n');
        fprintf(fid,'%14.0f %6.0f %6.0f\n',Capacity');
        fprintf(fid,'                                     ]\n\n');
    fprintf(fid,'TotCap :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f %4.0f %4.0f\n',TotCap');
        fprintf(fid,'                                     ]\n\n');
    fprintf(fid,'CharterCost :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f %4.0f %4.0f\n',CharterCost');
        fprintf(fid,'                                     ]\n\n');   
    fprintf(fid,'CostS :[\n');
        fprintf(fid,'%14.0f\n',CostS');
        fprintf(fid,'                                     ]\n\n');   
    fprintf(fid,'CapacityS :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f\n',CapacityS');
        fprintf(fid,'                                     ]\n\n');   
    fprintf(fid,'TotCapS :[\n');
        fprintf(fid,'%14.0f\n',TotCapS');
        fprintf(fid,'                                     ]\n\n');   
fclose(fid);




