function [ Node_st ] = VesselNode()
clc
clear all
nRows = 6;         % Row size of matrix
nColumns = 4;      % Column size of matrix
minZeroes = 2;      % Constraint 1 (for columns)
minRowSum = 2;      % Constraint 2 (for rows)
%

function vector = make_column
vector = [false(minZeroes,1); true(nRows-minZeroes,1)];  % Create vector
  [vector,maxLength] = randomize_column(vector);           % Randomize order
end

function [vector,maxLength] = randomize_column(vector)
vector = vector(randperm(nRows));          % Randomize order
  edges = diff([false; vector; false]);      % Find rising and falling edges
  maxLength = max(find(edges == -1)-find(edges == 1));  % Find longest                                                      % sequence of ones
end

Node_st = false(nRows,nColumns);  % Initialize matrix
for iColumn = 1:nColumns,
  Node_st(:,iColumn) = make_column;  % Create each column
end

rowSum = sum(Node_st,2);

while any(rowSum < minRowSum),            % Loop while constraint 2 is not met
  [minValue,rowIndex] = min(rowSum);      % Find row with lowest sum
  zeroIndex = find(~Node_st(rowIndex,:));  % Find zeroes in that row
  randIndex = round(1+rand.*(numel(zeroIndex)-1));
  columnIndex = zeroIndex(randIndex);     % Choose a zero at random
  column = Node_st(:,columnIndex);
  while ~column(rowIndex),                % Loop until zero changes to one
    column = make_column;                 % Make new column vector
  end
  Node_st(:,columnIndex) = column;         % Update binary matrix
  rowSum = sum(Node_st,2);                 % Update row sum vector
end
Node_st
end
